function [d, diff] = bidirectional(dlr, drl, hWin, dBounds, threshold)

[rows, cols] = size(dlr);

diff = zeros(size(dlr));
dMin = min(dBounds);
dMax = max(dBounds);
cs = max([1, 1 + dMax]);
ce = min([cols, cols + dMin]);
col = cs:ce;
for r = (1 + hWin):(rows - hWin)
    diff(r, cs:ce) = abs(dlr(r, cs:ce) - drl(r, col - dlr(r, cs:ce)));
end
check = diff <= threshold;
d1 = double(check) .* (dlr + drl) / 2;
d = NaN + zeros(size(d1));
d((1 + hWin):(rows - hWin), cs:ce) = d1((1 + hWin):(rows - hWin), cs:ce);