function cen = census(img, halfWin)

[rows, cols] = size(img);

% Make pixel displacements
index = (-halfWin):halfWin;
n = length(index);
row = index' * ones(1, n);
col = ones(n, 1) * index;
delta = col * rows + row;

validRows = (halfWin+1):(rows-halfWin);
validCols = (halfWin+1):(cols-halfWin);

if islogical(img)
    med = img;
else
    med = medfilt2(img, [3 3]);
end

cen = logical(zeros(rows, cols, n * n - 1));
k = 1;
for r = 1:n
    for c = 1:n
        if ~(row(r, c) == 0 & col(r, c) == 0)
            if islogical(img)
                block = img(validRows + row(r, c), validCols + col(r, c)) == ...
                    med(validRows, validCols);
            else
                block = img(validRows + row(r, c), validCols + col(r, c)) < ...
                    med(validRows, validCols);
            end
            cen(validRows, validCols, k) = block;
            k = k + 1;
        end
    end
end