#include "types.h"
#include <stdio.h>
#include "tell.h"

#define CHECKBITS(var, type, bits) if (sizeof(var) * 8 != bits) \
	{ \
		if (warn) tell(f, "correctIntTypes: %s has %d bits instead of %d", type, sizeof(var) * 8, bits); \
		return f; \
	}

logical correctIntTypes(logical warn)
{
	int8 i8 = 0;
	int16 i16 = 0;
	int32 i32 = 0;

	uint8 u8 = 0;
	uint16 u16 = 0;
	uint32 u32 = 0;

	real32 r32 = 0.0;
	real64 r64 = 0.0;

	CHECKBITS(i8, "int8", 8);
	CHECKBITS(i16, "int16", 16);
	CHECKBITS(i32, "int32", 32);

	CHECKBITS(u8, "uint8", 8);
	CHECKBITS(u16, "uint16", 16);
	CHECKBITS(u32, "uint32", 32);

	CHECKBITS(r32, "real32", 32);
	CHECKBITS(r64, "real64", 64);

	return t;
}