l = uint8(imread('left.pgm'));
r = uint8(imread('right.pgm'));

% Half of the window size for the census transform
hWin = 7;

% Minimum and maximum disparity (must be nonnegative)
dBounds = [0 30];

% Acceptable difference in disparity when matching left->right and right->left
threshold = 2;

% Carve out a detail (census transform is slow code!)
detRows = 31:130;
detCols = 101:260;
l = l(detRows, detCols);
r = r(detRows, detCols);

[rows, cols] = size(l);

figure(1)
clf
set(gcf, 'Position', [40 400 1000 380])
subplot(1, 2, 1)
imagesc(l)
axis image
axis off
subplot(1, 2, 2)
imagesc(r)
axis image
axis off
colormap gray

disp('Computing the census transform. This may take a while')
[d, dlr, drl, diff, Hlr, Hrl] = censusMatch(l, r, hWin, dBounds, threshold);

figure(2)
clf
imagesc(d)
axis image
axis off
colormap gray
title('Stereo results from raw census transform block matching')

cost = uint8(Hlr);

disp('Computing dynamic programming solution')
[ld, rd] = dps(cost);

ldc = ld(:); ldc(find(ldc == 255)) = NaN; ldc = reshape(ldc, size(ld));
rdc = rd(:); rdc(find(rdc == 255)) = NaN; rdc = reshape(rdc, size(rd));

figure(3);
imagesc(ldc)
axis image
colormap gray
title('Stereo results from dynamic programming using the census transform')